<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.13" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="indexpage" kind="group">
    <compoundname>index</compoundname>
    <title>Cypress CSDADC Middleware Library</title>
    <detaileddescription>
<para>The CSDADC middleware is the Cypress ADC solution that uses the CSD HW block.The CSD HW block is mainly used to implement the touch sense applications and proximity sensors (refer to the <ulink url="https://cypresssemiconductorco.github.io/capsense/capsense_api_reference_manual/html/index.html">CapSense Middleware API Reference Guide</ulink>), but can also be used to implement the ADC, which is especially useful for the devices that do not include another hardware option to implement the ADC. CSDADC provides the following measurement capabilities:<itemizedlist>
<listitem><para>Voltage monitoring on multiple external channels. Any GPIO that can be connected to AMUX-B (refer to the particular device datasheet for information) can be an input to the CSDADC under software control.</para></listitem><listitem><para>Voltage monitoring on AMUX-B.</para></listitem><listitem><para>Device supply voltage (VDDA) monitoring without the need of explicitly connecting VDDA to a GPIO input of the ADC. This capability can be used to measure battery voltages and/or change VDDA-dependent parameters of the ADC during run-time.</para></listitem></itemizedlist>
</para><para>The listed capabilities are making the CSDADC useful for a variety of applications, including home appliances, automotive, IoT, and industrial applications. The CSDADC middleware can use the same CSD HW block with other CSD-based middleware (CapSense, CSDIDAC, etc) in time-multiplexed manner.</para><para><bold>Features:</bold><itemizedlist>
<listitem><para>ADC with 8- and 10-bit resolution</para></listitem><listitem><para>Two input measurement ranges: GND to VREF and GND to VDDA</para></listitem><listitem><para>Two operation modes: Continuous conversion and Single-shot conversion</para></listitem></itemizedlist>
</para>
<para><heading level="1">General Description</heading></para>
<para>Include cy_csdadc.h to get access to all functions and other declarations in this library. The <ref kindref="member" refid="index_1group_csdadc_quick_start">Quick Start Guide</ref> is offered in this API Reference Guide.</para><para>Refer to the <ref kindref="member" refid="index_1section_csdadc_toolchain">Supported Software and Tools</ref> for the compatibility information.</para><para>Refer to the <ref kindref="member" refid="index_1group_csdadc_changelog">Changelog</ref> for the differences between the Middleware versions.</para><para>The <ref kindref="member" refid="index_1group_csdadc_changelog">Changelog</ref> also describes the impact of the changes to your code.</para><para>The CSD HW block enables multiple sensing capabilities on PSoC devices including the self-cap and mutual-cap capacitive touch sensing solutions, a 10-bit ADC, IDAC, and Comparator. The CSD driver is a low-level peripheral driver, a wrapper to manage access to the CSD HW block. Any middleware access to the CSD HW block happens through the CSD Driver.</para><para>The CSD HW block can support only one function at a time. However, all supported functionality (like CapSense, CSDADC, etc.) can be time-multiplexed in a design. I.e. you can save the existing state of the CapSense middleware, restore the state of the CSDADC middleware, perform ADC measurements, and then switch back to the CapSense functionality. For more details and code examples, refer to the description of the <ref kindref="member" refid="group__group__csdadc__functions_1gac34d548ef9dd0d65c874abff00995cab">Cy_CSDADC_Save()</ref> and <ref kindref="member" refid="group__group__csdadc__functions_1ga63d187dca4825b702bcdb5ff73a7aef7">Cy_CSDADC_Restore()</ref> functions.</para><para><image name="capsense_solution.png" type="html" width="800px">CapSense Solution</image>
 
</para><para>This section describes only the CSDADC middleware. Refer to the corresponding sections for documentation of other middleware supported by the CSD HW block. The CSDADC library is designed to use with the CSD driver. The application program does not need to interact with the CSD driver and/or other drivers such as GPIO or SysClk directly. All of that is configured and managed by the middleware.</para><para>The CSDADC API is described in the following sections:<itemizedlist>
<listitem><para><ref kindref="compound" refid="group__group__csdadc__macros">Macros</ref></para></listitem><listitem><para><ref kindref="compound" refid="group__group__csdadc__data__structures">Data Structures</ref></para></listitem><listitem><para><ref kindref="compound" refid="group__group__csdadc__enums">Enumerated types</ref></para></listitem><listitem><para><ref kindref="compound" refid="group__group__csdadc__functions">Functions</ref></para></listitem></itemizedlist>
</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition warning"&gt;&lt;p class="admonition-title"&gt;warning&lt;/p&gt;&lt;p&gt;&lt;p&gt;I2C transactions during ADC conversions may lead to measurement result distortions. Perform ADC conversions and I2C communications in Time-sharing mode.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim></para>

<para><heading level="1">Quick Start Guide</heading></para>
<para>Cypress CSDADC middleware can be used in various Development Environments such as ModusToolbox, MBED, etc. Refer to the <ref kindref="member" refid="index_1section_csdadc_toolchain">Supported Software and Tools</ref>. The quickest way to get started is using the Code Examples. Cypress Semiconductor continuously extends its portfolio of the code examples at the <ulink url="http://www.cypress.com">Cypress Semiconductor website</ulink> and at the <ulink url="https://github.com/cypresssemiconductorco">Cypress Semiconductor GitHub</ulink>.</para><para>This quick start guide assumes that the environment is configured to use the PSoC 6 Peripheral Driver Library(psoc6pdl) for development and the PSoC 6 Peripheral Driver Library(psoc6pdl) is included in the project.</para><para>The following steps are required to set up the CSDADC and to run the measurement:<orderedlist>
<listitem><para>Set up the CSDADC configuration manually or by using the Device Configurator as described in the <ref kindref="member" refid="index_1group_csdadc_configuration">Configuration Considerations</ref> section. <verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;Put the CSDADC name to the Alias field of the CSD resource if the Device Configurator is used.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim></para></listitem><listitem><para>Include cy_csdadc.h to get access to all CSDADC API and cy_pdl.h to get access to API of peripheral drivers according to the example below: <programlisting><codeline><highlight class="preprocessor">#include<sp />"cy_pdl.h"</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cy_csdadc.h"</highlight><highlight class="normal" /></codeline>
</programlisting></para></listitem><listitem><para>If you use the MBED OS, include the cycfg.h file to get access to the System Configuration: <programlisting><codeline><highlight class="preprocessor">#include<sp />"cycfg.h"</highlight><highlight class="normal" /></codeline>
</programlisting></para></listitem><listitem><para>Declare the 'cy_csdadc_context' variable as per example below: <programlisting><codeline><highlight class="comment">/*<sp />CSDADC<sp />context<sp />declaration<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><ref kindref="compound" refid="structcy__stc__csdadc__context__t">cy_stc_csdadc_context_t</ref><sp />cy_csdadc_context;</highlight></codeline>
</programlisting></para></listitem><listitem><para>Declare and initialize the CSDADC_ISR_cfg variable as per example below: <programlisting><codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keyword">const</highlight><highlight class="normal"><sp />cy_stc_sysint_t<sp />CSDADC_ISR_cfg<sp />=</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.intrSrc<sp />=<sp />csd_interrupt_IRQn,<sp /><sp /></highlight><highlight class="comment">/*<sp />Interrupt<sp />source<sp />is<sp />the<sp />CSD<sp />interrupt<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.intrPriority<sp />=<sp />7u,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Interrupt<sp />priority<sp />is<sp />7<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
</programlisting></para></listitem><listitem><para>Define the CSDADC interrupt handler according to the example below: <programlisting><codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />CSDADC_Interrupt(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__csdadc__functions_1ga514703b9e2da7cc3adf497198558e9b0">Cy_CSDADC_InterruptHandler</ref>(CSDADC_HW,<sp />&amp;cy_csdadc_context);</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
</programlisting></para></listitem><listitem><para>Update the main() routine with the following code: <programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />ch0Result;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />ch1Result;</highlight></codeline>
</programlisting><programlisting><codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />The<sp />mask<sp />to<sp />enable<sp />conversion<sp />on<sp />Channel-0<sp />and<sp />Channel-1.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />channelsMask<sp />=<sp />0x03u;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />UNCOMMENT<sp />THIS<sp />CODE<sp />if<sp />you<sp />use<sp />the<sp />MBED<sp />OS:<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//init_cycfg_clocks();</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//init_cycfg_routing();</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//init_cycfg_peripherals();</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />UNCOMMENT<sp />THIS<sp />CODE<sp />if<sp />you<sp />Implement<sp />the<sp />initialization<sp />code<sp />manually</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp />*<sp /><sp />to<sp />Assign<sp />the<sp />Peripheral<sp />Clock<sp />Divider<sp />to<sp />the<sp />CSD<sp />HW<sp />block.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//Cy_SysClk_PeriphAssignDivider(PCLK_CSD_CLOCK,<sp />CY_SYSCLK_DIV_8_BIT,<sp />0u);</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />UNCOMMENT<sp />THIS<sp />CODE<sp />if<sp />you<sp />Implement<sp />the<sp />initialization<sp />code<sp />manually<sp />to</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp />*<sp /><sp />set<sp />configuration<sp />of<sp />the<sp />HSIOM_AMUX_SPLIT_CTL<sp />switches.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//#if(1u<sp />==<sp />CY_IP_MXS40IOSS_VERSION)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp /><sp />HSIOM-&gt;AMUX_SPLIT_CTL[4]<sp />=<sp />HSIOM_AMUX_SPLIT_CTL_SWITCH_BB_SL_Msk<sp />|</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />HSIOM_AMUX_SPLIT_CTL_SWITCH_BB_SR_Msk;</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//#elif(2u<sp />==<sp />CY_IP_MXS40IOSS_VERSION)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp /><sp />HSIOM-&gt;AMUX_SPLIT_CTL[4]<sp />=<sp />HSIOM_V2_AMUX_SPLIT_CTL_SWITCH_BB_SL_Msk<sp />|</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />HSIOM_V2_AMUX_SPLIT_CTL_SWITCH_BB_SR_Msk;</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//#else</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp /><sp />#error<sp />Not<sp />supported<sp />device</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//#endif</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Captures<sp />the<sp />CSD<sp />HW<sp />block<sp />and<sp />Initializes<sp />it<sp />to<sp />the<sp />default<sp />state.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__csdadc__functions_1ga539700892c4ce6ca9c0d076a53a796a9">Cy_CSDADC_Init</ref>(&amp;CSDADC_csdadc_config,<sp />&amp;cy_csdadc_context);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Initializes<sp />the<sp />CSDADC<sp />interrupt.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />Cy_SysInt_Init(&amp;CSDADC_ISR_cfg,<sp />&amp;CSDADC_Interrupt);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />NVIC_ClearPendingIRQ(CSDADC_ISR_cfg.intrSrc);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />NVIC_EnableIRQ(CSDADC_ISR_cfg.intrSrc);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Initializes<sp />the<sp />CSDADC<sp /><sp />firmware<sp />modules.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__csdadc__functions_1gace0ef0fd816a147c2821877644da81b7">Cy_CSDADC_Enable</ref>(&amp;cy_csdadc_context);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">for</highlight><highlight class="normal">(;;)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__csdadc__enums_1gga2fb51073513c86f28616c29901c55a40a18e1e8f2c080c1697eaf0de8757a2ae4">CY_CSDADC_SUCCESS</ref><sp />==<sp /><ref kindref="member" refid="group__group__csdadc__functions_1ga2fe1d5b92fcbbb85230cce544818ce59">Cy_CSDADC_StartConvert</ref>(<ref kindref="member" refid="group__group__csdadc__enums_1ggaa708440f81ca9ab9606919c8a2b55f7ba68c510fb301d723422dd6ea2fbed7f93">CY_CSDADC_SINGLE_SHOT</ref>,<sp />channelsMask,<sp />&amp;cy_csdadc_context))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">while</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__csdadc__enums_1gga2fb51073513c86f28616c29901c55a40a18e1e8f2c080c1697eaf0de8757a2ae4">CY_CSDADC_SUCCESS</ref><sp />!=<sp /><ref kindref="member" refid="group__group__csdadc__functions_1gabb93b3cee2724658cd14d603569cbba6">Cy_CSDADC_IsEndConversion</ref>(&amp;cy_csdadc_context))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Waits<sp />for<sp />the<sp />end<sp />of<sp />conversions.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Stores<sp />the<sp />Channel-0<sp />measurement<sp />result<sp />to<sp />the<sp />ch0Result<sp />variable.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />ch0Result<sp />=<sp /><ref kindref="member" refid="group__group__csdadc__functions_1gac7f07b8602ab61912a1f3424d5a864c0">Cy_CSDADC_GetResultVoltage</ref>(0u,<sp />&amp;cy_csdadc_context);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Stores<sp />the<sp />Channel-1<sp />measurement<sp />result<sp />to<sp />the<sp />ch1Result<sp />variable.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />ch1Result<sp />=<sp /><ref kindref="member" refid="group__group__csdadc__functions_1gac7f07b8602ab61912a1f3424d5a864c0">Cy_CSDADC_GetResultVoltage</ref>(1u,<sp />&amp;cy_csdadc_context);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
</programlisting></para></listitem></orderedlist>
</para>

<para><heading level="1">Configuration Considerations</heading></para>
<para>The CSDADC middleware operates on the top of the CSD Driver included in the PSoC 6 Peripheral Driver Library (psoc6pdl). Refer to the "CSD(CapSense
Sigma Delta)" section of the PSoC 6 Peripheral Driver Library (psoc6pdl) API Reference Manual. This Configuration Considerations section guides how to set up the CSDADC middleware for the operation with the following parameters:<orderedlist>
<listitem><para>Device VDDA: 3.3V.</para></listitem><listitem><para>Device Peri Clock frequency: 48MHz.</para></listitem><listitem><para>Desired Number of Input Channels: 2 (Ch-1 is assigned to P6[2], Ch-2 is assigned to P6[3]).</para></listitem><listitem><para>Desired Resolution: 10 bit.</para></listitem><listitem><para>Desired Measurement Range: GND to VDDA.</para></listitem></orderedlist>
</para><para>There are two methods for the CSDADC Middleware configuration:<orderedlist>
<listitem><para><ref kindref="member" refid="index_1group_csdadc_mtb_configuring">Use ModusToolbox Device Configurator Tool to generate initialization code</ref></para></listitem><listitem><para><ref kindref="member" refid="index_1group_csdadc_manual_configuring">Implement the initialization code manually</ref></para></listitem></orderedlist>
</para><para>Generation of the initialization code using the <ulink url="https://www.cypress.com/ModusToolboxDeviceConfig">ModusToolbox Device Configurator Tool </ulink> which is part of the <ulink url="https://www.cypress.com/products/modustoolbox-software-environment">ModusToolbox</ulink>, greatly simplifies the PSoC configuration. The <ulink url="https://www.cypress.com/ModusToolboxDeviceConfig">ModusToolbox Device Configurator Tool </ulink> provides the user interface to set up and automatically generate the initialization code (including analog routing) and configuration structures.</para><para>Manual implementation of the initialization code (including analog routing) and configuration structures is recommended for expert Users only. This will include the code for the following settings which in case of the Device Configurator usage are generated automatically based upon the settings entered in its UI:<itemizedlist>
<listitem><para>Assigning the Peripheral Clock Divider.</para></listitem><listitem><para>Configuring the HSIOM_AMUX_SPLIT_CTL switches to route signal from input pins configured as the CSDADC channels to the CSD HW block.</para></listitem><listitem><para>Declaration and initialization of the CSDADC configuration structure.</para></listitem><listitem><para>Declaration and initialization of the CSD HW driver context structure.</para></listitem><listitem><para>Definition of the of the CSD HW block base address.</para></listitem></itemizedlist>
</para>
<para><bold>Use ModusToolbox Device Configurator Tool to generate initialization code</bold></para>
<para>The following steps are required to generate the initialization code using the <ulink url="https://www.cypress.com/ModusToolboxDeviceConfig">ModusToolbox Device Configurator Tool </ulink>:<orderedlist>
<listitem><para>Launch the ModusToolbox Middleware Selector and enable the CSD ADC middleware. This step is required only if the ModusToolbox IDE is used. Otherwise, ensure the CSDADC Middleware is included in your project.</para></listitem><listitem><para>Launch the ModusToolbox Device Configurator Tool.</para></listitem><listitem><para>Switch to the System tab. Configure the CLK_PERI frequency to achieve 48MHz (you may need to change the FLL or PLL frequency) and set the VDDA voltage to 3.3V in Power/MCU Personality.</para></listitem><listitem><para>Switch to the Peripherals tab (#1 on figure below). Enable the CSD personality under System (#2 on figure below) and enter Alias (#3 on figure below). We use CSDADC in <ref kindref="member" refid="index_1group_csdadc_quick_start">Quick Start Guide</ref>.</para></listitem><listitem><para>Go to the Parameters Pane and configure the CSD Personality:<itemizedlist>
<listitem><para>Assign the peripheral clock divider by using the Clock combo box(#4 on figure below). Any free divider can be used.</para></listitem><listitem><para>Set the Enable CSDADC check box (#5 on figure below).</para></listitem><listitem><para>Configure the CSDADC with the desired parameters per <ref kindref="member" refid="index_1group_csdadc_configuration">Configuration Considerations</ref> (#5 on figure below).</para></listitem><listitem><para>Assign the CSDADC Channels to pins per <ref kindref="member" refid="index_1group_csdadc_configuration">Configuration Considerations</ref> (#6 on figure below).</para></listitem></itemizedlist>
</para></listitem><listitem><para>Perform File-&gt;Save to generate initialization code.</para></listitem></orderedlist>
</para><para><image name="csdadc_config.png" type="html" width="1175px">CSDADC configuration</image>
 
</para><para>Now, all required CSDADC initialization code and configuration prerequisites will be generated:<itemizedlist>
<listitem><para>The Peripheral Clock Divider assignment and analog routing are parts of the init_cycfg_all() routine. Place the call of the init_cycfg_all() function before using any CSDADC API functions to ensure initialization of all external resources required for the CSDADC operation. Refer to the main() routine code snippet in <ref kindref="member" refid="index_1group_csdadc_quick_start">Quick Start Guide</ref></para></listitem><listitem><para>The CSDADC configuration structure declaration in the cycfg_peripherals.h file and its initialization in the cycfg_peripherals.c file. The variable name is &lt;Alias_Name&gt;_csdadc_config.</para></listitem><listitem><para>The CSD HW driver context structure declaration in the cycfg_peripherals.h file and its initialization in the cycfg_peripherals.c file. The variable name is cy_csd_&lt;CSD_Block_Index&gt;_context.</para></listitem><listitem><para>The CSD HW block base address definition is in the cycfg_peripherals.h file.</para></listitem><listitem><para>The definition name is &lt;Alias_Name&gt;_HW.</para></listitem></itemizedlist>
</para><para>The generated code will be available under the GeneratedSource folder.</para><para>Refer to <ref kindref="member" refid="index_1group_csdadc_quick_start">Quick Start Guide</ref> section for the application layer code required to set up CSDADC and run the measurement.</para>

<para><bold>Implement the initialization code manually</bold></para>
<para>The steps required to implement the initialization code manually:<orderedlist>
<listitem><para>Launch the ModusToolbox Middleware Selector and enable the CSD ADC middleware. This step is required only if the ModusToolbox IDE is used. Otherwise, ensure the CSDADC Middleware is included in your project.</para></listitem><listitem><para>Define the CSD HW block base address. See the code example below: <programlisting><codeline><highlight class="preprocessor">#define<sp />CSDADC_HW<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(CSD0)</highlight></codeline>
</programlisting></para></listitem><listitem><para>Declare the CSD HW driver context structure and initialize the lockKey field with the CY_CSD_NONE_KEY value. See the code example below: <programlisting><codeline><highlight class="normal">cy_stc_csd_context_t<sp />cy_csd_context<sp />=</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.lockKey<sp />=<sp />CY_CSD_NONE_KEY,<sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Initialization<sp />of<sp />the<sp />lockKey<sp />with<sp />the<sp />CY_CSD_NONE_KEY</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />is<sp />required<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">};</highlight></codeline>
</programlisting></para></listitem><listitem><para>Declare the CSDADC configuration structure and initialize it according to the desired parameters. See the code example below: <programlisting><codeline><highlight class="preprocessor">#define<sp />PERI_DIV_INDEX_0<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(0u)</highlight></codeline>
</programlisting><programlisting><codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcy__stc__csdadc__ch__pin__t">cy_stc_csdadc_ch_pin_t</ref><sp />chList[2u]<sp />=</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{GPIO_PRT6,<sp />2u},<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Assign<sp />channel-0<sp />to<sp />P6[2]<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{GPIO_PRT6,<sp />3u}<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Assign<sp />channel-1<sp />to<sp />P6[3]<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keyword">const</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcy__stc__csdadc__config__t">cy_stc_csdadc_config_t</ref><sp />CSDADC_csdadc_config<sp />=</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.<ref kindref="member" refid="structcy__stc__csdadc__config__t_1af0839917f36aa586434fd2c07a042043">ptrPinList</ref><sp />=<sp />chList,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Points<sp />to<sp />the<sp />array<sp />with<sp />configured<sp />CSDACD<sp />Ports/Pins.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.base<sp />=<sp />CSDADC_HW,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />The<sp />CSD0<sp />HW<sp />block<sp />is<sp />selected<sp />for<sp />CSDADC<sp />operation.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.csdCxtPtr<sp />=<sp />&amp;cy_csd_context,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Points<sp />to<sp />the<sp />CSD<sp />driver<sp />context<sp />structure.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.cpuClk<sp />=<sp />48000000u,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Provides<sp />an<sp />absolute<sp />CPU<sp />clock<sp />frequency<sp />in<sp />the<sp />current<sp />design<sp />(configured<sp />to<sp />48MHz).<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.periClk<sp />=<sp />48000000u,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Provides<sp />an<sp />absolute<sp />Peri<sp />clock<sp />frequency<sp />in<sp />the<sp />current<sp />design<sp />(configured<sp />to<sp />48MHz).<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.vref<sp />=<sp />-1,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Sets<sp />auto-selection<sp />of<sp />the<sp />reference<sp />voltage.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.vdda<sp />=<sp />3300u,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Provides<sp />Supply<sp />Voltage<sp />in<sp />the<sp />current<sp />design<sp />(configured<sp />to<sp />3.3V).<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.calibrInterval<sp />=<sp />0u,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Reserved<sp />for<sp />further<sp />enhancements.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.range<sp />=<sp /><ref kindref="member" refid="group__group__csdadc__enums_1gga9a51f670bcf385f7f2cbaa3f1491cc7fab08c3bcb3f06d7cd7c0e1bed9b17df8c">CY_CSDADC_RANGE_VDDA</ref>,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Selects<sp />the<sp />measurement<sp />range<sp />(configured<sp />to<sp />GND<sp />to<sp />VDDA).<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.resolution<sp />=<sp /><ref kindref="member" refid="group__group__csdadc__enums_1gga53be63f99ad2c3e775496df7c8957bc7a9332e87810c8e564b2fa586aede1193d">CY_CSDADC_RESOLUTION_10BIT</ref>,<sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Selects<sp />the<sp />measurement<sp />resolution<sp />(configured<sp />to<sp />the<sp />10-bit<sp />resolution).<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.periDivTyp<sp />=<sp />CY_SYSCLK_DIV_8_BIT,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Pass<sp />the<sp />type<sp />of<sp />clock<sp />divider,<sp />used<sp />to<sp />clock<sp />the<sp />CSD<sp />HW<sp />block.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />On<sp />the<sp />application<sp />layer,<sp />assign<sp />the<sp />same<sp />type<sp />divider<sp />by<sp />using<sp />the</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Cy_SysClk_PeriphAssignDivider()<sp />function.<sp />The<sp />CSDADC<sp />middleware<sp />requires<sp />information</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />about<sp />the<sp />used<sp />divider<sp />to<sp />be<sp />able<sp />to<sp />control<sp />it<sp />in<sp />the<sp />run<sp />time<sp />(enable/disable,<sp />change<sp />value).<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.numChannels<sp />=<sp />2u,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Configured<sp />CSDADC<sp />MW<sp />to<sp />measure<sp />the<sp />voltage<sp />on<sp />two<sp />channels.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.idac<sp />=<sp />31u,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Reserved<sp />for<sp />further<sp />enhancements.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.operClkDivider<sp />=<sp />1u,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Defines<sp />the<sp />value<sp />to<sp />be<sp />set<sp />by<sp />CSDADC<sp />in<sp />the<sp />run<sp />time<sp />to<sp />the<sp />clock<sp />divider,<sp />assigned<sp />on</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />the<sp />application<sp />layer<sp />by<sp />using<sp />the<sp />Cy_SysClk_PeriphAssignDivider()<sp />function.<sp />The<sp />Max<sp />supported</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />clock<sp />frequency<sp />for<sp />the<sp />CSD<sp />HW<sp />block<sp />is<sp />50<sp />MHz.<sp />The<sp />divider<sp />value<sp />"1"<sp />is<sp />used,<sp /></highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />because<sp />in<sp />the<sp />current<sp />case<sp />the<sp />Peri<sp />Clock<sp />frequency<sp />is<sp />48<sp />MHz.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.azTime<sp />=<sp />5u,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Configures<sp />Auto-zero<sp />time<sp />to<sp />5<sp />us<sp />(as<sp />default).<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.acqTime<sp />=<sp />10u,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Configures<sp />Acquisition<sp />time<sp />to<sp />10<sp />us<sp />(as<sp />default).<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.csdInitTime<sp />=<sp />25u,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Configures<sp />the<sp />CSD0<sp />wake-up<sp />initialization<sp />time<sp />to<sp />25<sp />us<sp />(as<sp />default).<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.idacCalibrationEn<sp />=<sp />0u,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Reserved<sp />for<sp />further<sp />enhancements.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.periDivInd<sp />=<sp />PERI_DIV_INDEX_0,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Pass<sp />the<sp />index<sp />of<sp />the<sp />clock<sp />divider<sp />used<sp />to<sp />clock<sp />the<sp />CSD<sp />HW<sp />block.<sp /></highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Assign<sp />divider<sp />with<sp />the<sp />same<sp />index<sp />on<sp />the<sp />application<sp />layer<sp />by<sp />using<sp />the</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Cy_SysClk_PeriphAssignDivider()<sp />function.<sp />The<sp />CSDADC<sp />middleware<sp />requires<sp />information</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />about<sp />the<sp />used<sp />divider<sp />to<sp />be<sp />able<sp />to<sp />control<sp />it<sp />in<sp />the<sp />run<sp />time<sp />(enable/disable,<sp />change<sp />value).<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">};</highlight></codeline>
</programlisting></para></listitem><listitem><para>Assign the Peripheral Clock Divider to the CSD HW block. See the code example below and refer to the main() routine code snippet in <ref kindref="member" refid="index_1group_csdadc_quick_start">Quick Start Guide</ref> <programlisting><codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*</highlight></codeline>
<codeline><highlight class="comment">*<sp />The<sp />user<sp />responsibility<sp />is<sp />to<sp />assign<sp />the<sp />peripheral<sp />clock<sp />divider<sp />to<sp />the</highlight></codeline>
<codeline><highlight class="comment">*<sp />CSD<sp />HW<sp />block<sp />on<sp />application<sp />layer.<sp />Any<sp />free<sp />divider<sp />of<sp />any<sp />type<sp />can<sp />be<sp />used.</highlight></codeline>
<codeline><highlight class="comment">*</highlight></codeline>
<codeline><highlight class="comment">*<sp />PCLK_CSD_CLOCK<sp />-<sp />connect<sp />divider<sp />to<sp />the<sp />CSD<sp />HW<sp />block</highlight></codeline>
<codeline><highlight class="comment">*<sp />CY_SYSCLK_DIV_8_BIT<sp />-<sp />use<sp />8-bit<sp />divider.</highlight></codeline>
<codeline><highlight class="comment">*<sp />PERI_DIV_INDEX_0<sp />-<sp />select<sp />divider<sp />with<sp />index<sp />#0.<sp /></highlight></codeline>
<codeline><highlight class="comment">*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">Cy_SysClk_PeriphAssignDivider(PCLK_CSD_CLOCK,<sp />CY_SYSCLK_DIV_8_BIT,<sp />PERI_DIV_INDEX_0);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
</programlisting></para></listitem><listitem><para>Set the configuration of the HSIOM_AMUX_SPLIT_CTL switches to route signal from input pins configured as the CSDADC channels to the CSD HW block. The AMUX_SPLIT_CTL[4] switches are closed to connect port P6 with the CSD HW block. Refer to the <ulink url="http://www.cypress.com/trm218176">Technical Reference Manual (TRM)</ulink> for more information regarding the analog interconnection. See the code example below and refer to the main() routine code snippet in <ref kindref="member" refid="index_1group_csdadc_quick_start">Quick Start Guide</ref> <programlisting><codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#if(1u<sp />==<sp />CY_IP_MXS40IOSS_VERSION)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />HSIOM-&gt;AMUX_SPLIT_CTL[4]<sp />=<sp />HSIOM_AMUX_SPLIT_CTL_SWITCH_BB_SL_Msk<sp />|<sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Closes<sp />the<sp />left<sp />AMUX-B<sp />switch<sp />of<sp />AMUX<sp />splitter<sp />#4.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />HSIOM_AMUX_SPLIT_CTL_SWITCH_BB_SR_Msk;<sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Closes<sp />the<sp />right<sp />AMUX-B<sp />switch<sp />of<sp />AMUX<sp />splitter<sp />#4.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#elif(2u<sp />==<sp />CY_IP_MXS40IOSS_VERSION)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />HSIOM-&gt;AMUX_SPLIT_CTL[4]<sp />=<sp />HSIOM_V2_AMUX_SPLIT_CTL_SWITCH_BB_SL_Msk<sp />|<sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Closes<sp />the<sp />left<sp />AMUX-B<sp />switch<sp />of<sp />AMUX<sp />splitter<sp />#4.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />HSIOM_V2_AMUX_SPLIT_CTL_SWITCH_BB_SR_Msk;<sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Closes<sp />the<sp />right<sp />AMUX-B<sp />switch<sp />of<sp />AMUX<sp />splitter<sp />#4.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#else</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#error<sp />Not<sp />supported<sp />device</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#endif<sp /></highlight><highlight class="comment">/*<sp />(1u<sp />==<sp />CY_IP_MXS40IOSS_VERSION)<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
</programlisting> Refer to <ref kindref="member" refid="index_1group_csdadc_quick_start">Quick Start Guide</ref> section for the application layer code required to set up CSDADC and run the measurement.</para></listitem></orderedlist>
</para>


<para><heading level="1">Use Cases</heading></para>
<para>This section provides descriptions and links to additional documentation for some specific CSDADC use cases.</para>
<para><bold>Low Power Design</bold></para>
<para>The CSD HW block and CSDADC middleware can operate in CPU active and CPU sleep power modes. It is also possible to switch between low power and ultra low power system modes. The CSD HW block interrupt can wake-up the CPU from sleep mode. In System Deep Sleep and Hibernate power modes, the CSD HW block is powered off and CSDADC conversions are not performed. When the device wakes up from CPU / System Deep Sleep, the CSD HW block resumes operation without the need for re-initialization and the CSDADC conversions can be continued with a configuration that was set before CPU / System Deep Sleep transition. When the device wakes up from System Hibernate power mode, the CSD HW block does not retain configuration and CSDADC requires re-initialization. If the user performs some communications to transmit CSDADC results via I2C, UART etc., transitions to CPU sleep, Deep Sleep or Hibernate modes are performed with recommendations both for CSDADC and communications' drivers/middleware.</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;&lt;ol&gt;&lt;li&gt;&lt;p&gt;CPU can seamlessly enter and exit CPU sleep mode while the CSD HW block is busy. However, do not put the CSD HW block into block low power mode during the conversion as it may lead to unexpected behavior.&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;Entering CPU Deep Sleep mode does not mean the device enters System Deep Sleep. For more detail about switching to System Deep Sleep, refer to the device TRM.&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;The analog start-up time for the CSD HW block is 25 us. Initiate any kind of conversion only after 25 us from System Deep Sleep / Hibernate exit.&lt;/p&gt;&lt;/li&gt;&lt;/ol&gt;&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;Refer to the </verbatim><ref kindref="member" refid="group__group__csdadc__functions_1gae5a2d7cf6f3e1c4ce0da1512480dc9c8">Cy_CSDADC_DeepSleepCallback()</ref> function description and to the SysPm (System Power Management) driver documentation for the low power design considerations.</para><para><bold>Sleep mode</bold><linebreak />
 The CSD HW block can operate in the CPU sleep mode. The user can start CSDADC and move a CPU into sleep mode. After every conversion, the CPU is woken-up by the CSD interrupt, the results are read, and the CPU goes to sleep again to reduce a power consumption. After the whole conversion cycle completes, the user can read results, proccess them, and start a new cycle. Then, the user configures the CSDADC middleware as described in <ref kindref="member" refid="index_1group_csdadc_configuration">Configuration Considerations</ref>, and updates the main() routine with the following code: <programlisting><codeline><highlight class="normal"><sp /><sp /></highlight><highlight class="comment">/*<sp />Scenario:<sp />There<sp />is<sp />a<sp />need<sp />to<sp />measure<sp />two<sp />input<sp />voltages<sp />while<sp />CPU<sp />is<sp />in<sp />Sleep<sp />mode<sp /></highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp />*<sp />during<sp />conversions.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />...<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">for</highlight><highlight class="normal"><sp />(;;)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Starts<sp />CSDADC<sp />measuring<sp />of<sp />the<sp />two<sp />input<sp />channel<sp />voltages.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__csdadc__enums_1gga2fb51073513c86f28616c29901c55a40a18e1e8f2c080c1697eaf0de8757a2ae4">CY_CSDADC_SUCCESS</ref><sp />==<sp /><ref kindref="member" refid="group__group__csdadc__functions_1ga2fe1d5b92fcbbb85230cce544818ce59">Cy_CSDADC_StartConvert</ref>(<ref kindref="member" refid="group__group__csdadc__enums_1ggaa708440f81ca9ab9606919c8a2b55f7ba68c510fb301d723422dd6ea2fbed7f93">CY_CSDADC_SINGLE_SHOT</ref>,<sp />channelsMask,<sp />&amp;cy_csdadc_context))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">while</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__csdadc__enums_1gga2fb51073513c86f28616c29901c55a40a18e1e8f2c080c1697eaf0de8757a2ae4">CY_CSDADC_SUCCESS</ref><sp />!=<sp /><ref kindref="member" refid="group__group__csdadc__functions_1gabb93b3cee2724658cd14d603569cbba6">Cy_CSDADC_IsEndConversion</ref>(&amp;cy_csdadc_context))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp /></highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp />Goes<sp />to<sp />CPU<sp />Sleep<sp />mode<sp />and<sp />waits<sp />for<sp />a<sp />CSDADC<sp />interrupt.<sp /></highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp />CSDADC<sp />handles<sp />the<sp />interrupt<sp />and<sp />CPU<sp />enters<sp />Sleep<sp />mode<sp />again.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp />The<sp />results<sp />are<sp />being<sp />read<sp />and<sp />proccessed<sp />after<sp />the<sp />whole<sp /></highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp />conversion<sp />cycle<sp />completion.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(CY_SYSPM_SUCCESS<sp />!=<sp />Cy_SysPm_CpuEnterSleep(CY_SYSPM_WAIT_FOR_INTERRUPT))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />You<sp />can<sp />place<sp />error<sp />handler<sp />code<sp />here.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Stores<sp />the<sp />Channel-0<sp />measurement<sp />result<sp />to<sp />the<sp />ch0Result<sp />variable.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />ch0Result<sp />=<sp /><ref kindref="member" refid="group__group__csdadc__functions_1gac7f07b8602ab61912a1f3424d5a864c0">Cy_CSDADC_GetResultVoltage</ref>(0u,<sp />&amp;cy_csdadc_context);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Stores<sp />the<sp />Channel-1<sp />measurement<sp />result<sp />to<sp />the<sp />ch1Result<sp />variable.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />ch1Result<sp />=<sp /><ref kindref="member" refid="group__group__csdadc__functions_1gac7f07b8602ab61912a1f3424d5a864c0">Cy_CSDADC_GetResultVoltage</ref>(1u,<sp />&amp;cy_csdadc_context);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp /></highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp />Insert<sp />here<sp />a<sp />CSDADC<sp />data<sp />processing<sp />here,<sp />because<sp />the<sp />data<sp />will<sp />be<sp />lost<sp /></highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp />after<sp />the<sp />next<sp />Sleep<sp />entering.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />You<sp />can<sp />place<sp />error<sp />handler<sp />code<sp />here.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
</programlisting> <bold>Deep Sleep mode</bold><linebreak />
 To use the CSDADC middleware in the CPU / System Deep Sleep mode, the user configures a wake-up source (e.g. a pin, WDT, LPC or another entities, that are active in CPU / System Deep Sleep mode), configures the CSDADC middleware as described in <ref kindref="member" refid="index_1group_csdadc_configuration">Configuration Considerations</ref>, configures CSDADC and other drivers' and middleware's (if presented) Deep Sleep Callback structures, registers callbacks, and updates the main() routine with the following code: <programlisting><codeline><highlight class="comment">/*<sp />CSDADC<sp />DeepSleep<sp />Callback<sp />parameters<sp />structure<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">cy_stc_syspm_callback_params_t<sp />CSDADC_deepSleepParamStr<sp />=</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />CSDADC_HW,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Points<sp />to<sp />the<sp />CSD<sp />HW<sp />block<sp />base<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />&amp;cy_csdadc_context,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Points<sp />to<sp />the<sp />CSDADC<sp />context<sp />structure<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp /><sp />CSDADC<sp />DeepSleep<sp />Callback<sp />structure<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">cy_stc_syspm_callback_t<sp />CSDADC_deepSleepCallbackStr<sp />=</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />&amp;<ref kindref="member" refid="group__group__csdadc__functions_1gae5a2d7cf6f3e1c4ce0da1512480dc9c8">Cy_CSDADC_DeepSleepCallback</ref>,<sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Points<sp />to<sp />the<sp />CSDADC<sp />Callback<sp />function<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />CY_SYSPM_DEEPSLEEP,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />The<sp />Callback<sp />type<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />0u,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />The<sp />skip<sp />modes<sp />mask<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />&amp;CSDADC_deepSleepParamStr,<sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Points<sp />to<sp />the<sp />Callback<sp />parameters<sp />structure<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />NULL,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Reserved<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />NULL,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Reserved<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />10u,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />The<sp />callback<sp />priority,<sp />can<sp />be<sp />from<sp />1<sp />(the<sp />highest)<sp />to<sp />255<sp />(the<sp />lowest)*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">};</highlight></codeline>
</programlisting><programlisting><codeline><highlight class="normal"><sp /><sp /></highlight><highlight class="comment">/*<sp />Scenario:<sp />There<sp />is<sp />a<sp />need<sp />to<sp />measure<sp />two<sp />input<sp />voltages<sp />one<sp />time<sp /></highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp />*<sp />per<sp />one<sp />wake-up<sp />event,<sp />and<sp />the<sp />rest<sp />of<sp />time<sp />the<sp />CPU<sp />should<sp />be<sp />in<sp />Deep<sp />Sleep<sp />mode.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />...<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Registers<sp />CSDADC<sp />DeepSleep<sp />Callback.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(</highlight><highlight class="keyword">true</highlight><highlight class="normal"><sp />!=<sp />Cy_SysPm_RegisterCallback(&amp;CSDADC_deepSleepCallbackStr))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />You<sp />can<sp />place<sp />error<sp />handler<sp />code<sp />here.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />...<sp />*/</highlight><highlight class="normal"><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">for</highlight><highlight class="normal"><sp />(;;)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Waits<sp />for<sp />the<sp />conversions<sp />completion<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__csdadc__enums_1gga2fb51073513c86f28616c29901c55a40a18e1e8f2c080c1697eaf0de8757a2ae4">CY_CSDADC_SUCCESS</ref><sp />==<sp /><ref kindref="member" refid="group__group__csdadc__functions_1gabb93b3cee2724658cd14d603569cbba6">Cy_CSDADC_IsEndConversion</ref>(&amp;cy_csdadc_context))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Stores<sp />the<sp />Channel-0<sp />measurement<sp />result<sp />to<sp />the<sp />ch0Result<sp />variable.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />ch0Result<sp />=<sp /><ref kindref="member" refid="group__group__csdadc__functions_1gac7f07b8602ab61912a1f3424d5a864c0">Cy_CSDADC_GetResultVoltage</ref>(0u,<sp />&amp;cy_csdadc_context);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Stores<sp />the<sp />Channel-1<sp />measurement<sp />result<sp />to<sp />the<sp />ch1Result<sp />variable.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />ch1Result<sp />=<sp /><ref kindref="member" refid="group__group__csdadc__functions_1gac7f07b8602ab61912a1f3424d5a864c0">Cy_CSDADC_GetResultVoltage</ref>(1u,<sp />&amp;cy_csdadc_context);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp /></highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp />Insert<sp />CSDADC<sp />data<sp />processing<sp />here,<sp />because<sp />the<sp />data<sp />will<sp />be<sp />lost<sp /></highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp />after<sp />the<sp />next<sp />DeepSleep<sp />entering.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp />...<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp />After<sp />the<sp />CSDADC<sp />data<sp />proccessing<sp />completion,<sp />the<sp />CPU<sp />goes<sp />to<sp />Deep<sp />Sleep</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp />and<sp />waits<sp />for<sp />an<sp />interrupt.<sp />It<sp />is<sp />the<sp />user's<sp />responsibility<sp /></highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp />to<sp />provide<sp />an<sp />interrupt<sp />source<sp />for<sp />a<sp />reliable<sp />CPU<sp />wake-up.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(CY_SYSPM_SUCCESS<sp />!=<sp />Cy_SysPm_CpuEnterDeepSleep(CY_SYSPM_WAIT_FOR_INTERRUPT))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />You<sp />can<sp />place<sp />error<sp />handler<sp />code<sp />here.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Wakes<sp />up<sp />CSDADC<sp />after<sp />a<sp />successful<sp />exit<sp />from<sp />Deep<sp />Sleep.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__csdadc__functions_1gafa9c2a4610c5f2e242c1c01c79511560">Cy_CSDADC_Wakeup</ref>(&amp;cy_csdadc_context);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp />After<sp />Deep<sp />Sleep,<sp />CPU<sp />and<sp />CSD<sp />HW<sp />block<sp />wake-up,<sp />CSDADC<sp />starts<sp />with<sp />two<sp />input<sp />channel<sp />voltages<sp />measuring.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__csdadc__enums_1gga2fb51073513c86f28616c29901c55a40a18e1e8f2c080c1697eaf0de8757a2ae4">CY_CSDADC_SUCCESS</ref><sp />!=<sp /><ref kindref="member" refid="group__group__csdadc__functions_1ga2fe1d5b92fcbbb85230cce544818ce59">Cy_CSDADC_StartConvert</ref>(<ref kindref="member" refid="group__group__csdadc__enums_1ggaa708440f81ca9ab9606919c8a2b55f7ba68c510fb301d723422dd6ea2fbed7f93">CY_CSDADC_SINGLE_SHOT</ref>,<sp />channelsMask,<sp />&amp;cy_csdadc_context))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp /></highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp />You<sp />can<sp />place<sp />error<sp />handler<sp />code<sp />here.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp />A<sp />software<sp />watchdog<sp />can<sp />be<sp />inserted<sp />here<sp />as<sp />well<sp /></highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp />to<sp />prevent<sp />a<sp />CSDADC<sp />hangout.<sp /></highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp /></highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp />Insert<sp />here<sp />some<sp />code,<sp />that<sp />can<sp />be<sp />done<sp />during<sp />CSDADC<sp />conversions<sp /></highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp />(if<sp />it<sp />is<sp />needed).</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
</programlisting></para>

<para><bold>ADC calibration</bold></para>
<para>Refer to the <ref kindref="member" refid="group__group__csdadc__functions_1ga2d96acbd1f2eae47d4bd97e41e0a3b7a">Cy_CSDADC_Calibrate()</ref> function description for the CSDADC calibration considerations. <ref kindref="member" refid="group__group__csdadc__functions_1gace0ef0fd816a147c2821877644da81b7">Cy_CSDADC_Enable()</ref> performs first-time calibration at the start of CSDADC operation. Periodical re-calibrations are required to keep the measurement results accurate.</para>

<para><bold>Time-multiplexing operation of CSDADC and CapSense</bold></para>
<para>Refer to the <ref kindref="member" refid="group__group__csdadc__functions_1gac34d548ef9dd0d65c874abff00995cab">Cy_CSDADC_Save()</ref> and <ref kindref="member" refid="group__group__csdadc__functions_1ga63d187dca4825b702bcdb5ff73a7aef7">Cy_CSDADC_Restore()</ref> functions descriptions to implementat the time-multiplexing operation of CSDADC and CapSense by using a common CSD HW block.</para>


<para><heading level="1">Supported Software and Tools</heading></para>
<para>This version of the CSDADC Middleware was validated for the compatibility with the following Software and Tools:</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;Software and Tools &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Version  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;ModusToolbox Software Environment &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;2.0  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;- ModusToolbox Device Configurator &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;2.0  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;- ModusToolbox CSD Personality in Device Configurator &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;2.0  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;PSoC6 Peripheral Driver Library (PDL) &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;1.2.0  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;GCC Compiler &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;7.2.1  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;IAR Compiler &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;8.32  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Arm Compiler 6 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;6.11  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;MBED OS &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;5.13.1  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;FreeRTOS &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;10.0.1  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>

<para><heading level="1">Update to Newer Versions</heading></para>
<para>Consult <ref kindref="member" refid="index_1group_csdadc_changelog">Changelog</ref> to learn about the design impact of the newer version. Set up your environment in accordance with <ref kindref="member" refid="index_1section_csdadc_toolchain">Supported Software and Tools</ref>. You might need to re-generate the configuration structures for either the device initialization code or the middleware initialization code.</para><para>Ensure:<itemizedlist>
<listitem><para>The specified version of the ModusToolbox Device Configurator and the CSD personality are used to re-generate the device configuration.</para></listitem><listitem><para>The toolchains are set up properly for your environment per the settings outlined in the Supported Software and Tools.</para></listitem><listitem><para>The project is re-built once the the toolchains are configured and the configuration is completed.</para></listitem></itemizedlist>
</para>

<para><heading level="1">MISRA-C Compliance</heading></para>
<para>The Cy_CSDADC library has the following specific deviations:</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;MISRA Rule &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Rule Class (Required/Advisory) &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Rule Description &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Description of Deviation(s)  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;11.4 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A conversion should not be performed between a pointer to object and an integer type. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Such a conversion is performed with the CSDADC context in two cases: the interrupt handler and DeepSleepCallback function. Both cases are verified on the correct operation.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.2 &lt;/p&gt;&lt;/td&gt;&lt;td rowspan="2"&gt;&lt;p&gt;R &lt;/p&gt;&lt;/td&gt;&lt;td rowspan="2"&gt;&lt;p&gt;Constant: Dereference of NULL pointer. &lt;/p&gt;&lt;/td&gt;&lt;td rowspan="2"&gt;&lt;p&gt;These violations are reported to result from using offset macros of the CSD Driver with corresponding documented violation 20.6. Refer to the CSD Driver API Ref Guide.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;20.3  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>

<para><heading level="1">Errata</heading></para>
<para>This section lists the known problems with the CSDADC middleware:</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;Cypress ID&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Known Issue&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Workaround &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;319100 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The GPIO simultaneous operation with unrestricted strength and frequency creates noise that can affect the CSDADC operation.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Refer to the errata section of the device datasheet for details.&lt;br /&gt; &lt;a href="http://www.cypress.com/ds218787"&gt;PSoC 63 with BLE Datasheet Programmable System-on-Chip&lt;/a&gt;   &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>

<para><heading level="1">Changelog</heading></para>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;Version&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Changes&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Reason for Change &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="8"&gt;&lt;p&gt;2.0 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Made public the CY_CSDADC_NO_CHANNEL macro &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Defect fixing  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Changed the &lt;a href="group__group__csdadc__functions.html#group__group__csdadc__functions_1ga514703b9e2da7cc3adf497198558e9b0"&gt;Cy_CSDADC_InterruptHandler()&lt;/a&gt; function prototype. Added function argument: const CSD_Type * base  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;User experience improvement  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Changed the &lt;a href="group__group__csdadc__functions.html#group__group__csdadc__functions_1ga2fe1d5b92fcbbb85230cce544818ce59"&gt;Cy_CSDADC_StartConvert()&lt;/a&gt; function prototype. Changed the mode argument type from uint32_t to cy_en_csdadc_conversion_mode_t &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;User experience improvement  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Renamed function Cy_CSDADC_ConversionStatus() to &lt;a href="group__group__csdadc__functions.html#group__group__csdadc__functions_1ga984982a9e928f7380555ee375384915a"&gt;Cy_CSDADC_GetConversionStatus()&lt;/a&gt; &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;User experience improvement  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;The CSDADC MW sources are enclosed with the conditional compilation to ensure a successful compilation for non-CSDADC-capable devices &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A compilation for non-CSDADC-capable devices  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;After conversion, the ADC channel is still connected to the CSD HW block, and disconnected only prior to new channel connection &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Defect fixing  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Changed the &lt;a href="structcy__stc__csdadc__config__t.html#"&gt;cy_stc_csdadc_config_t&lt;/a&gt; structure: the ptrPin field is replaced with the ptrPinList field. It is a pointer to the array of the size determined by the numChannels field of this structure versus the ptrPin field that was an array of pointers with fixed &lt;a href="group__group__csdadc__macros.html#group__group__csdadc__macros_1ga7a2c27abd3dd05754a37d9accbc7fa49"&gt;CY_CSDADC_MAX_CHAN_NUM&lt;/a&gt; size. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;User experience improvement  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Added the cpuClk field to the &lt;a href="structcy__stc__csdadc__config__t.html#"&gt;cy_stc_csdadc_config_t&lt;/a&gt; structure. Changed the software watchdog counter calculation in the &lt;a href="group__group__csdadc__functions.html#group__group__csdadc__functions_1ga63d187dca4825b702bcdb5ff73a7aef7"&gt;Cy_CSDADC_Restore()&lt;/a&gt; function where cpuClk is used instead of periClk. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Defect fixing  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="2"&gt;&lt;p&gt;1.0.1 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Improvements to documentation &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;User experience improvement  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Forbidden usage of CSDADC for non-CSDADC-capable devices in module.mk file &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A Compilation for non-CSDADC-capable devices  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.0 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The initial version &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>

<para><heading level="1">More Information</heading></para>
<para>For more information, refer to the following documents:</para><para><itemizedlist>
<listitem><para><ulink url="https://www.cypress.com/products/modustoolbox-software-environment">ModusToolbox Software Environment, Quick Start Guide, Documentation, and Videos</ulink></para></listitem><listitem><para><ulink url="https://github.com/cypresssemiconductorco">CSDADC Middleware Code Example for MBED OS</ulink></para></listitem><listitem><para><ulink url="https://github.com/cypresssemiconductorco">CSDADC Middleware Code Examples at GITHUB</ulink></para></listitem><listitem><para><ulink url="https://www.cypress.com/ModusToolboxDeviceConfig">ModusToolbox Device Configurator Tool Guide</ulink></para></listitem><listitem><para><ulink url="https://cypresssemiconductorco.github.io/capsense/capsense_api_reference_manual/html/index.html">CapSense Middleware API Reference Guide</ulink></para></listitem><listitem><para><ulink url="https://cypresssemiconductorco.github.io/csdidac/csdidac_api_reference_manual/html/index.html">CSDIDAC Middleware API Reference Guide</ulink></para></listitem><listitem><para><ulink url="https://github.com/cypresssemiconductorco.github.io/psoc6pdl/pdl_api_reference_manual/html/index.html">PDL API Reference</ulink></para></listitem><listitem><para><ulink url="https://www.cypress.com/documentation/technical-reference-manuals/psoc-6-mcu-psoc-63-ble-architecture-technical-reference">PSoC 6 Technical Reference Manual</ulink></para></listitem><listitem><para><ulink url="http://www.cypress.com/ds218787">PSoC 63 with BLE Datasheet Programmable System-on-Chip datasheet</ulink></para></listitem><listitem><para><ulink url="http://www.cypress.com">Cypress Semiconductor</ulink></para></listitem></itemizedlist>
</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;The links to another software component's documentation (middleware and PDL) point to GitHub to the latest available version of the software. To get documentation of the specified version, download from GitHub and unzip the component archive. The documentation is available in the &lt;i&gt;docs&lt;/i&gt; folder. &lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim></para>
    </detaileddescription>
  </compounddef>
</doxygen>